#include "mymalloc.h"

#define HEAP_SIZE 8192

static int heap_inited = 0;
static char heap[HEAP_SIZE];

void OS_heap_init(void)
{
    heap_inited = 1;
}

static void OS_heap_error(void)
{
    // Heap error
    while (1) {}
}

void * OS_malloc(size_t size)
{
    static int index = 0;
    char *p;
    
    if (heap_inited == 0 || index >= HEAP_SIZE) {
        OS_heap_error();
    }
    
    // NOTE: This is only an example for testing!
    // Do not use this implementation in other applications!
    p = &heap[index];
    index += size;

    return p;
}

void OS_free(void* ptr)
{
    // ...
}
